<div class="default-content-padding">
  <h3>Dodaj nowe zdarzenie</h3>
  <app-loading-spinner [show]="showSpinner"></app-loading-spinner>
  <form [formGroup]="formGroup">
    <mat-vertical-stepper
      #linearVerticalStepper="matVerticalStepper"
      formArrayName="formArray"
      [linear]="true"
      (selectionChange)="onSelectionChanged($event)">

      <mat-step formGroupName="0" [stepControl]="formArray?.get([0])">
        <ng-template matStepLabel>Szczegóły zdarzenia</ng-template>

        <mat-form-field>
          <mat-label>Tytuł</mat-label>
          <input matInput #titleInput formControlName="titleFormCtrl" maxlength="70" required>
          <mat-hint align="end">{{titleInput.value?.length || 0}}/70</mat-hint>
          <mat-error>To pole jest wymagane</mat-error>
        </mat-form-field>

        <app-chip-autocomplete-input
          #lineInput
          [label]="'Wybierz linie'"
          [required]="true"
          (chosenValuesChanged)="updateLines($event)"
          (valid)="updateLineInputValidity($event)"
        ></app-chip-autocomplete-input>

        <mat-form-field>
          <mat-label>Opis</mat-label>
          <textarea matInput #descriptionInput formControlName="descFormCtrl" maxlength="256"></textarea>
          <mat-hint align="end">{{descriptionInput.value?.length || 0}}/255</mat-hint>
          <mat-error>To pole jest wymagane.</mat-error>
        </mat-form-field>

        <div>
          <button mat-flat-button color="primary" matStepperNext>Dalej</button>
        </div>

      </mat-step>

      <mat-step formGroupName="1" [stepControl]="formArray?.get([1])">
        <ng-template matStepLabel>Lokalizacja</ng-template>

        <app-coordinates-input (coordinates)="updateCoordinates($event)"></app-coordinates-input>
        <mat-error class="top-padding" *ngIf="!this.formArray.get([1]).get('latFormCtrl').value">Musisz wskazać
          lokalizację zdarzenia na mapie.
        </mat-error>

        <div class="button-row top-padding">
          <button mat-flat-button matStepperPrevious>Wróć</button>
          <button mat-flat-button color="primary" matStepperNext>Dalej</button>
        </div>

      </mat-step>

      <mat-step formGroupName="2" [stepControl]="formArray?.get([2])">
        <ng-template matStepLabel>Zdjęcia</ng-template>

        <app-photo-uploader (photosListChanged)="updatePhotosToSubmit($event)"></app-photo-uploader>

        <div class="button-row top-padding">
          <button mat-flat-button matStepperPrevious>Wróć</button>
          <button mat-flat-button color="primary" matStepperNext>Dalej</button>
        </div>

      </mat-step>

      <mat-step>

        <ng-template matStepLabel>Sprawdź zgłoszenie</ng-template>

        <mat-card>
          <mat-card-header>
            <mat-card-title>{{this.formArray.get([0]).get('titleFormCtrl').value}}</mat-card-title>
            <mat-card-subtitle>Linie:
              <span
                *ngFor="let line of this.formArray.get([0]).get('lineFormCtrl').value; let isLast=last">{{line}}{{isLast ? '' : ', '}}</span>
            </mat-card-subtitle>
          </mat-card-header>
          <app-display-map mat-card-image [zoom]=20
                           [coordinates]="{lat: this.formArray.get([1]).get('latFormCtrl').value,
                          lng: this.formArray.get([1]).get('lonFormCtrl').value}"
                           class="display-map">
          </app-display-map>
          <mat-carousel mat-card-image
                        [maintainAspectRatio]="false"
                        slideHeight="250px"
                        [loop]="false"
                        color="primary"
                        [hideIndicators]="this.formArray.get([2]).get('photoURLFormCtrl').value?.length === 1"
                        [hideArrows]="this.formArray.get([2]).get('photoURLFormCtrl').value?.length === 1"
                        [autoplay]="false">
            <mat-carousel-slide
              [overlayColor]="'#00000010'"
              *ngFor="let photoURL of this.formArray.get([2]).get('photoURLFormCtrl').value">
              <div class="event-photo">
                <img [src]="photoURL">
              </div>
            </mat-carousel-slide>
          </mat-carousel>
          <mat-card-content *ngIf="this.formArray.get([2]).get('photoURLFormCtrl').value ||
                       this.formArray.get([0]).get('descFormCtrl').value">
            <p>
              {{this.formArray.get([0]).get('descFormCtrl').value}}
            </p>
          </mat-card-content>
        </mat-card>

        <div class="button-row top-padding">
          <button mat-flat-button matStepperPrevious>Wróć</button>
          <button mat-flat-button color="primary" matStepperNext (click)="submitPost()">Zgłoś</button>
        </div>

      </mat-step>

    </mat-vertical-stepper>
  </form>
</div>

